module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmory imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmory exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		Object.defineProperty(exports, name, {
/******/ 			configurable: false,
/******/ 			enumerable: true,
/******/ 			get: getter
/******/ 		});
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 45);
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/query.js":
/***/ function(module, exports, __webpack_require__) {

"use strict";
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.operators = undefined;

var _keys = __webpack_require__(0);

var _keys2 = _interopRequireDefault(_keys);

exports.query = query;
exports.testWithOperator = testWithOperator;

var _get = __webpack_require__(9);

var _get2 = _interopRequireDefault(_get);

var _some = __webpack_require__(27);

var _some2 = _interopRequireDefault(_some);

var _eq = __webpack_require__(17);

var _eq2 = _interopRequireDefault(_eq);

var _isMatch = __webpack_require__(21);

var _isMatch2 = _interopRequireDefault(_isMatch);

var _isRegExp = __webpack_require__(6);

var _isRegExp2 = _interopRequireDefault(_isRegExp);

var _isEqual = __webpack_require__(20);

var _isEqual2 = _interopRequireDefault(_isEqual);

var _lt = __webpack_require__(24);

var _lt2 = _interopRequireDefault(_lt);

var _lte = __webpack_require__(25);

var _lte2 = _interopRequireDefault(_lte);

var _gt = __webpack_require__(18);

var _gt2 = _interopRequireDefault(_gt);

var _gte = __webpack_require__(19);

var _gte2 = _interopRequireDefault(_gte);

var _isObject = __webpack_require__(23);

var _isObject2 = _interopRequireDefault(_isObject);

var _isString = __webpack_require__(7);

var _isString2 = _interopRequireDefault(_isString);

var _isNumber = __webpack_require__(22);

var _isNumber2 = _interopRequireDefault(_isNumber);

var _isArray = __webpack_require__(1);

var _isArray2 = _interopRequireDefault(_isArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var equals = _eq2.default;
var not_equals = function not_equals() {
  return !_eq2.default.apply(undefined, arguments);
};
var neq = function neq() {
  return !_eq2.default.apply(undefined, arguments);
};

var operators = exports.operators = {
  lt: _lt2.default, gt: _gt2.default, gte: _gte2.default, lte: _lte2.default, eq: _eq2.default, neq: neq, equals: equals, not_equals: not_equals
};

/**
 * Query an array using a parameters hash which allows for different operators,
 * and which can easily be serialized and sent over the wire
 *
 */

function query() {
  var nodeList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var params = arguments[1];
  var negate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  if (typeof nodeList.filter !== 'function') {
    console.log(nodeList);
    return [];
  }

  if (typeof params === 'function') {
    return nodeList.filter(params);
  }

  var items = nodeList || [];

  return items.filter(function (node) {
    var matchesParam = (0, _keys2.default)(params).every(function (key) {
      var param = params[key];
      var value = (0, _get2.default)(node, key);

      if ((0, _isRegExp2.default)(param) && param.test(value)) {
        return true;
      }

      if (typeof param === 'string' && value === param) {
        return true;
      }

      if (typeof param === 'number' && value === param) {
        return true;
      }

      // treat normal arrays to search for some exact matches
      if ((0, _isArray2.default)(param) && ((0, _isString2.default)(value) || (0, _isNumber2.default)(value))) {
        return (0, _some2.default)(param, function (val) {
          return val === value;
        });
      }

      if ((0, _isObject2.default)(param) && (param.value || param.val) && (param.op || param.operator)) {
        return testWithOperator(param, value);
      }

      if ((0, _isObject2.default)(param) && (0, _isObject2.default)(value)) {
        return (0, _isMatch2.default)(value, param);
      }
    });

    return negate ? !matchesParam : matchesParam;
  });
}

exports.default = query;
function testWithOperator(param, testValue) {
  var operator = param.operator || param.op;
  var checkValue = param.value || param.val;
  var testFn = operators[operator] || _isEqual2.default;

  return testFn(testValue, checkValue);
}

/***/ },

/***/ 0:
/***/ function(module, exports) {

module.exports = require("babel-runtime/core-js/object/keys");

/***/ },

/***/ 1:
/***/ function(module, exports) {

module.exports = require("lodash/isArray");

/***/ },

/***/ 17:
/***/ function(module, exports) {

module.exports = require("lodash/eq");

/***/ },

/***/ 18:
/***/ function(module, exports) {

module.exports = require("lodash/gt");

/***/ },

/***/ 19:
/***/ function(module, exports) {

module.exports = require("lodash/gte");

/***/ },

/***/ 20:
/***/ function(module, exports) {

module.exports = require("lodash/isEqual");

/***/ },

/***/ 21:
/***/ function(module, exports) {

module.exports = require("lodash/isMatch");

/***/ },

/***/ 22:
/***/ function(module, exports) {

module.exports = require("lodash/isNumber");

/***/ },

/***/ 23:
/***/ function(module, exports) {

module.exports = require("lodash/isObject");

/***/ },

/***/ 24:
/***/ function(module, exports) {

module.exports = require("lodash/lt");

/***/ },

/***/ 25:
/***/ function(module, exports) {

module.exports = require("lodash/lte");

/***/ },

/***/ 27:
/***/ function(module, exports) {

module.exports = require("lodash/some");

/***/ },

/***/ 45:
/***/ function(module, exports, __webpack_require__) {

module.exports = __webpack_require__("./src/query.js");


/***/ },

/***/ 6:
/***/ function(module, exports) {

module.exports = require("lodash/isRegExp");

/***/ },

/***/ 7:
/***/ function(module, exports) {

module.exports = require("lodash/isString");

/***/ },

/***/ 9:
/***/ function(module, exports) {

module.exports = require("lodash/get");

/***/ }

/******/ });